//---------------------------------------------------------------------------
//
//   UVSmartSnap
//
//          Copyright(C) 2014, Tark
//
//  UVɌ̊JȂ_Xibv
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <unordered_map>
#include <algorithm>
#include "MQPlugin.h"
#if MQPLUGIN_VERSION >= 0x0400
#include "MQ3DLib.h"
#include "MQWidget.h"
#endif
#include "CMQObject.h"
#include "UVSmartSnap.h"

static UVSmartSnap plugin;

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void UVSmartSnap::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID = 0xBD9A187E;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *UVSmartSnap::GetPlugInName(void)
{
	return "UVSmartSnap ver.1.0 Copyright(C) 2014, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *UVSmartSnap::EnumString()
{
	return "UVSmartSnap";
}

//---------------------------------------------------------------------------
//  Initialize
//---------------------------------------------------------------------------
BOOL UVSmartSnap::Initialize()
{
	return TRUE;
}

//---------------------------------------------------------------------------
//  Exit
//---------------------------------------------------------------------------
void UVSmartSnap::Exit()
{
}

//---------------------------------------------------------------------------
//  Activate
//---------------------------------------------------------------------------
BOOL UVSmartSnap::Activate(MQDocument doc, BOOL flag)
{
	m_bActivate = flag ? true : false;
	if(m_bActivate) {
	}
	return m_bActivate;
}

//---------------------------------------------------------------------------
//  IsActivated
//---------------------------------------------------------------------------
BOOL UVSmartSnap::IsActivated(MQDocument doc)
{
	return m_bActivate;
}

// vOC̃x[XNXԂ
MQBasePlugin *GetPluginClass()
{
	return &plugin;
}

UVSmartSnap::UVSmartSnap() : m_Window(nullptr), m_bActivate(false)
{
}

UVSmartSnap::~UVSmartSnap()
{
}

// UVl(ق)_ɕނfmap_uvɑ}
bool gather_with_uv(cmq::CMQObject &obj, std::vector<std::vector<cmq::flindex_t>> &fmap_uv, std::unordered_map<cmq::findex_t, int> &uv_map, cmq::findex_t findex, int vidx, const cmq::CMQCoordinate &coord)
{
	for(int key = 0; key < fmap_uv.size(); key++) {
		if(fmap_uv[key].empty()) {
			continue;
		}
		auto target_flindex = fmap_uv[key].front();
		auto flpair = cmq::flId2FaceLinePair(target_flindex);
		auto carray = obj.getFaceCoordinateArray(flpair.first);
		auto target_coord = carray[flpair.second];
		if(cmq::CMQCoordinate::uvcomp(target_coord, coord)) {
			// ʒuUV
			fmap_uv[key].push_back(cmq::makeFaceLineId(findex, vidx));
			uv_map.insert(std::make_pair(findex, key));
			return true;
		}
	}
	uv_map.insert(std::make_pair(findex, fmap_uv.size()));
	std::vector<cmq::flindex_t> list;
	list.push_back(cmq::makeFaceLineId(findex, vidx));
	fmap_uv.push_back(list);
	return false;
}

// vector̗vf̈ʒuCfbNXŕԂ
int findvertex(const std::vector<cmq::vindex_t> &targetlist, cmq::vindex_t find)
{
	for(int i = 0; i < targetlist.size(); i++) {
		if(targetlist[i] == find) {
			return i;
		}
	}
	return -1;
}

cmq::vindex_t findSymmetryVertex(cmq::CMQObject &obj, cmq::vindex_t vindex, bool localflag)
{
	MQPoint vs(obj.getVertex(vindex));
	MQMatrix r;
	if(localflag) {
		r = obj.getLocalInverseMatrix();
		vs = vs * r;
	}
	vs.x = -vs.x;
	float dist = std::powf(0.5f, 2); // option.SymmetryDistance
	cmq::vindex_t vindex_symmetry = -1;
	cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer(&obj);
	for(auto vit = vcontainer.begin(); vit != vcontainer.end(); ++vit) {
		MQPoint v = obj.getVertex(vit.index());
		if(localflag) {
			v = v * r;
		}
		float d = (v - vs).norm();
		if(d < dist) {
			dist = d;
			vindex_symmetry = vit.index();
		}
	}
	return vindex_symmetry;
}

void UVSmartSnap::OnDraw(MQDocument doc_, MQScene scene, int width, int height)
{
	if(!IsActivated(doc_)) {
		return;
	}
	if(m_focusvindex != -1) {
		cmq::CMQDocument doc(doc_);
		cmq::CMQObject obj = doc.getCurrentObject();

		MQObject draw_ = CreateDrawingObject(doc_, DRAW_OBJECT_POINT);
		cmq::CMQObject draw(draw_, nullptr);
		draw_->SetColor(MQColor(1, 1, 0));
		draw_->SetColorValid(TRUE);
		// _ƂȂ\Ȃ̂ŕӂ

		MQPoint p1(obj.getVertex(m_focusvindex));
		draw.createLine(p1, p1);
	}
}

BOOL UVSmartSnap::OnMouseMove(MQDocument doc_, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	EDIT_OPTION option;
	GetEditOption(option);

	// Ώە̌mđI
	HIT_TEST_PARAM param;
	param.TestVertex = TRUE;
	param.TestLine = param.TestFace = FALSE;
	if(HitTest(scene, state.MousePos, param)) {
		m_focusvindex = param.VertexIndex;
		RedrawScene(scene);
	}
	else {
		m_focusvindex = -1;
	}
	return FALSE;
}

BOOL UVSmartSnap::OnLeftButtonDown(MQDocument doc_, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	if(!IsActivated(doc_)) {
		return FALSE;
	}
	cmq::CMQDocument doc(doc_);
	cmq::CMQObject obj = doc.getCurrentObject();

	// ҏWIvV擾
	EDIT_OPTION option;
	GetEditOption(option);

	// Ώە̌mđI
	HIT_TEST_PARAM param;
	param.TestVertex = TRUE;
	param.TestLine = param.TestFace = FALSE;
	if(HitTest(scene, state.MousePos, param)) {
		if(param.HitType == HIT_TYPE_VERTEX) {
			// INAĂ璸_IԂɂ
			doc_->ClearSelect(MQDOC_CLEARSELECT_ALL);
			m_vindex = param.VertexIndex;
			doc.addSelectVertex(obj, m_vindex);

			if(option.Symmetry) {
				// Ώ̒_
				m_vindex_symmetry = findSymmetryVertex(obj, m_vindex, option.CoordinateType == COORDINATE_LOCAL);
			}
#if _DEBUG
			OutputDebugString(L"OnLeftButtonDown: UpdateUndo\n");
#endif
			UpdateUndo();
			return TRUE;
		}
	}
	return FALSE;
}

BOOL UVSmartSnap::OnLeftButtonMove(MQDocument doc_, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	if(!IsActivated(doc_)) {
		return FALSE;
	}
	if(m_vindex == -1 ) {
		return FALSE;
	}

	// ҏWIvV擾
	EDIT_OPTION option;
	GetEditOption(option);

	cmq::CMQDocument doc(doc_);
	cmq::CMQObject obj = doc.getCurrentObject();

	if(state.RButton) {
		// hbOɉE{^FXibv
		MQPoint s0 = scene->Convert3DToScreen(obj.getVertex(m_vindex));
		cmq::vindex_t near_vindex = -1;

		// אږʂ̒_Xg쐬
		std::set<cmq::vindex_t> neighbors;
		auto faces = obj.getVertexRelatedFaces(m_vindex);
		for(cmq::findex_t findex : faces) {
			auto varray = obj.getFacePointArray(findex);
			auto index = findvertex(varray, m_vindex);
			if(index < 0) {
				// 肦Ȃ
				continue;
			}
			for(int i = 0; i < varray.size(); i++) {
				if(i != index) {
					neighbors.insert(varray[i]);
				}
			}
		}

		// אږʒ_̂AXibvΏۂ̒_T
		float distance = FLT_MAX;
		for(cmq::vindex_t vindex : neighbors) {
			MQPoint s1 = scene->Convert3DToScreen(obj.getVertex(vindex));
			MQPoint dist1 = s1 - s0;
			float dist = dist1.norm();
			if(dist < distance) {
				near_vindex = vindex;
				distance = dist;
			}
		}
		if(distance > 300.0f) {
			// Xibvאڒ_͂Ȃ
			return FALSE;
		}

		// _Xibv
		BOOL result = snap(doc, obj, m_vindex, near_vindex);
		m_vindex = -1;

		if(option.Symmetry) {
			cmq::vindex_t near_vindex_symmetry = findSymmetryVertex(obj, near_vindex, option.CoordinateType == COORDINATE_LOCAL);
			if(near_vindex_symmetry != -1) {
				BOOL result2 = snap(doc, obj, m_vindex_symmetry, near_vindex_symmetry);
				m_vindex_symmetry = -1;
			}
		}
		RedrawScene(scene);

		return result;
	}

	MQMatrix r, r2;
	if(option.CoordinateType == COORDINATE_LOCAL) {
		r = obj.getLocalInverseMatrix();
		r2 = obj.getLocal();
	}
	float out_w = 0;
	MQPoint vpos1 = obj.getVertex(m_vindex);
	MQPoint spos1 = scene->Convert3DToScreen(vpos1, &out_w);
	MQPoint spos2((float)state.MousePos.x, (float)state.MousePos.y, spos1.z);
	MQPoint vpos2 = scene->ConvertScreenTo3D(spos2);

	if(option.CoordinateType == COORDINATE_LOCAL) {
		vpos1 = vpos1 * r;
		vpos2 = vpos2 * r;
	}

	MQPoint vposvec = vpos2 - vpos1;
	MQPoint mpos = obj.getVertex(m_vindex);
	if(option.CoordinateType == COORDINATE_LOCAL) {
		mpos = mpos * r;
	}
	mpos += vposvec;

	if(option.Symmetry && m_vindex_symmetry != -1) {
		// Ώ̕ҏW
		MQPoint possym(mpos);
		possym.x = -possym.x;
		if(option.CoordinateType == COORDINATE_LOCAL) {
			possym = possym * r2;
		}
		obj.setVertex(m_vindex_symmetry, possym);
	}
	if(option.CoordinateType == COORDINATE_LOCAL) {
		mpos = mpos * r2;
	}
	obj.setVertex(m_vindex, mpos);

	RedrawScene(scene);
	return TRUE;
}

BOOL UVSmartSnap::OnLeftButtonUp(MQDocument doc_, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	if(!IsActivated(doc_)) {
		return FALSE;
	}
	m_vindex = m_vindex_symmetry = -1;
	UpdateUndo();
	return TRUE;
}

cmq::findex_t addPolygon(cmq::CMQObject &obj, const std::vector<int> &varray, const std::vector<cmq::CMQCoordinate> &carray, const std::vector<DWORD> &colarray, cmq::mindex_t mat)
{
	cmq::findex_t findex = obj.addFace(varray);
	obj.setFaceCoordinateArray(findex, carray);
	for(int i = 0; i < varray.size(); i++) {
		obj.setFaceVertexColor(findex, i, colarray[i]);
	}
	obj.setFaceMaterial(findex, mat);
	return findex;
}

struct FaceStruct
{
	int vindex;
	cmq::CMQCoordinate coord;
	DWORD color;
	FaceStruct(int v = -1, const cmq::CMQCoordinate &c = cmq::CMQCoordinate(), DWORD col = 0) : vindex(v), coord(c), color(col) {}
};

BOOL UVSmartSnap::snap(cmq::CMQDocument &doc, cmq::CMQObject &obj, cmq::vindex_t vindex, cmq::vindex_t target_vindex)
{
	std::unordered_map<cmq::findex_t, int> uv_map;
	std::vector<std::vector<cmq::flindex_t>> fmap_uv; // UV_ʒũ}bv
	std::unordered_map<cmq::findex_t, FaceStruct> fset_snap; // Xibv撸_܂ޖʂƁAXibv̖ʂ̃}bv
	std::unordered_map<cmq::findex_t, bool> fset_nosnap; // Xibv撸_܂܂Ȃʂi[(Xibvɍč쐬邩ǂtO)
	std::unordered_set<cmq::vindex_t> vset; // Ώۖʂ\S_i[iƂō폜肷邽߁j

	// hbO_אږʂUVʒuƂɕނ
	auto faces = obj.getVertexRelatedFaces(vindex);

	// hbO_אږʂ̒_Xg
	for(cmq::findex_t findex : faces) {
		auto varray = obj.getFacePointArray(findex);
		for(auto v : varray) {
			vset.insert(v);
		}
		auto carray = obj.getFaceCoordinateArray(findex);
		int vidx = findvertex(varray, vindex); // hbO_̔z񒆈ʒu
		if(vidx < 0) {
			// 肦Ȃ
			continue;
		}
		auto coord = carray[vidx];
		gather_with_uv(obj, fmap_uv, uv_map, findex, vidx, coord);

		bool insertflg = false;
		for(int i = 0; i < varray.size(); i++) {
			if(varray[i] == target_vindex) {
				// Xibv撸_܂ޖ
				fset_snap.insert(std::make_pair(findex, FaceStruct()));
				insertflg = true;
			}
		}
		if(!insertflg) {
			// Xibv撸_܂܂Ȃ
			fset_nosnap.insert(std::make_pair(findex, false));
		}
	}

	// _Xibv
	for(auto &fpair : fset_snap) {
		cmq::findex_t findex = fpair.first;
		// Xibv܂ޖ
		// hbO_폜āAXibv撸_܂ޖʂƂč蒼
		auto varray = obj.getFacePointArray(findex);
		int drag_vidx = findvertex(varray, vindex); // hbO_̔z񒆈ʒu
		int snap_vidx = findvertex(varray, target_vindex); // Xibv_̔z񒆈ʒu
		auto carray = obj.getFaceCoordinateArray(findex);
		std::vector<DWORD> colarray;
		for(int i = 0; i < varray.size(); i++) {
			colarray.push_back(obj.getFaceVertexColor(findex, i));
		}
		cmq::mindex_t mat = obj.getFaceMaterial(findex);
		if(((drag_vidx + 1) % varray.size()) == snap_vidx ||
			((snap_vidx + 1) % varray.size()) == drag_vidx) {
			// Xibv撸_hbO_̗אڒ_A1p炵ă|SƂč쐬
			varray.erase(varray.begin() + drag_vidx);
			carray.erase(carray.begin() + drag_vidx);
			colarray.erase(colarray.begin() + drag_vidx);
			if(varray.size() > 2) {
				cmq::findex_t newfindex = addPolygon(obj, varray, carray, colarray, mat);
			}
			int newsnap_vidx = drag_vidx > snap_vidx ? snap_vidx : snap_vidx - 1;
			FaceStruct fs(varray[newsnap_vidx], carray[newsnap_vidx], colarray[newsnap_vidx]);
			fpair.second = fs; // XibvUVWȂ
		}
		else {
			// אڒ_łȂA2|Sɕč쐬
			std::vector<cmq::vindex_t> newvarray[2];
			std::vector<cmq::CMQCoordinate> newcarray[2];
			std::vector<DWORD> newcolarray[2];
			int snapped_vidx[2];
			int phase = 0;
			for(int i = 0; i < varray.size(); i++) {
				if(i == drag_vidx) {
					phase = 1 - phase;
					continue;
				}
				if(i == snap_vidx) {
					snapped_vidx[phase] = newvarray[phase].size();
					newvarray[phase].push_back(varray[i]);
					newcarray[phase].push_back(carray[i]);
					newcolarray[phase].push_back(colarray[i]);
					phase = 1 - phase;
					snapped_vidx[phase] = newvarray[phase].size();

					FaceStruct fs(varray[i], carray[i], colarray[i]); // XibvUVWȂ
					fpair.second = fs;
				}
				newvarray[phase].push_back(varray[i]);
				newcarray[phase].push_back(carray[i]);
				newcolarray[phase].push_back(colarray[i]);
			}
			for(int j = 0; j < 2; j++) {
				if(newvarray[j].size() > 2) {
					cmq::findex_t newfindex = addPolygon(obj, newvarray[j], newcarray[j], newcolarray[j], mat);
				}
			}
		}
	}
	for(auto &fpair : fset_nosnap) {
		cmq::findex_t findex = fpair.first;
		// Xibv܂܂Ȃ
		auto varray = obj.getFacePointArray(findex);
		int drag_vidx = findvertex(varray, vindex); // hbO_̔z񒆈ʒu

		// Xibv܂ޖʂ̂hbO_UVlł̂T
		auto findit = uv_map.find(findex);
		if(findit == uv_map.end()) {
			// something wrong
			continue;
		}
		int keynum = findit->second;
		if(keynum >= fmap_uv.size()) {
			// something wrong
			continue;
		}
		auto &targetlist = fmap_uv[keynum];
		for(auto target_flindex : targetlist) {
			auto target_flpair = cmq::flId2FaceLinePair(target_flindex);
			auto findit = fset_snap.find(target_flpair.first);
			if(findit == fset_snap.end()) {
				continue;
			}
			auto fs = findit->second; // Xibv̒_AUVʒuA_F擾
		
			// hbO_Xibv撸_ɓւĖʂ蒼
			auto carray = obj.getFaceCoordinateArray(findex);
			std::vector<DWORD> colarray;
			for(int i = 0; i < varray.size(); i++) {
				colarray.push_back(obj.getFaceVertexColor(findex, i));
			}
			cmq::mindex_t mat = obj.getFaceMaterial(findex);
			varray[drag_vidx] = fs.vindex;
			carray[drag_vidx] = fs.coord;
			colarray[drag_vidx] = fs.color;
			cmq::findex_t newface = addPolygon(obj, varray, carray, colarray, mat);
			fpair.second = true;
			break;
		}
	}
	// ʍ폜	
	for(auto &fpair : fset_snap) {
		cmq::findex_t findex = fpair.first;
		obj.deleteFace(findex);
	}
	for(auto &fpair : fset_nosnap) {
		if(fpair.second) {
			obj.deleteFace(fpair.first);
		}
	}
	// ʂ\ȂȂ_폜
	for(auto v : vset) {
		if(obj.getVertexRelatedFaces(v).empty()) {
			obj.deleteVertex(v);
		}
	}
	return TRUE;
}
