#include "MQBasePlugin.h"

#ifndef _UIWindowDefine
#define _UIWindowDefine

class UVSmartSnapWindow;

// CNX
class UVSmartSnap : public MQCommandPlugin
{
public:
	UVSmartSnap();
	virtual ~UVSmartSnap();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(void);
	virtual BOOL Initialize();
	virtual void Exit();
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	virtual BOOL OnMouseMove(MQDocument doc_, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);

	typedef bool (UVSmartSnap::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);


private:
	UVSmartSnapWindow *m_Window;
	bool m_bActivate;

	cmq::vindex_t m_focusvindex;

	cmq::vindex_t m_vindex;
	cmq::vindex_t m_vindex_symmetry;

	BOOL snap(cmq::CMQDocument &doc, cmq::CMQObject &obj, cmq::vindex_t vindex, cmq::vindex_t near_vindex);

};

#endif
